// Blink example for ST NUCLEO-L476RG by RayeR (C) 2017
// LD2 (green) is at PA5 (pin #21 of 64)

#include <stm32l4xx.h>                 // part of STM32Cube_FW_L4 package
#include "system.h"                    // basic HW functions

int main()
{
  RCC->AHB2ENR|=RCC_AHB2ENR_GPIOAEN;   // enable AHB2 clock for GPIOA
  (void)RCC->AHB2ENR;                  // wait 1 AHB2 cycle (dummy read) for change being valid
  GPIOA->MODER|=GPIO_MODER_MODE5_0;    // set port mode:
  GPIOA->MODER&=~GPIO_MODER_MODE5_1;   // 00b=input, 01b=GP output, 10b=alt.func, 11b=analog (low-power)
  GPIOA->OTYPER&=~GPIO_OTYPER_OT5;     // 0=push-pull, 1=open-drain
  GPIOA->OSPEEDR&=~GPIO_OSPEEDR_OSPEED5_0; // set low output slew rate
  GPIOA->OSPEEDR&=~GPIO_OSPEEDR_OSPEED5_1; // 00=5MHz, 01=25MHz, 10=50MHz, 11=120MHz

  while (1)
    {
    GPIOA->ODR^=GPIO_ODR_OD5;          // toggle PA5 bit in Output Data register
    for (volatile long i=0; i<500000; i++); // make some delay
    }
}
